/**************************************************************************************************/
/*  Cal_Clf.C											  */
/**************************************************************************************************/
/*    Although I am far away to think this calculator can be useful as an aplication for accounter,
    
    Calc Vers 0.0001     Copyright (C)   2001 Marc Dechico

    This program is free software; you can redistribute it and/or modify
    it under the terms of the GNU General Public License as published by
    the Free Software Foundation; either version 2 of the License, or
    (at your option) any later version.

    This program is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.

    You should have received a copy of the GNU General Public License
    along with this program; if not, write to the Free Software
    Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA

    To contact the author:	Marc Dechico
			        Kerfring
			        29390 SCAER France
				tel: 06 80 83 74 99
				Mail: Marc.DECHICO@wanadoo.fr
    
*/
// Classe function for Cal 
// Function that handle one calculator window 
#include "Glo_Def.h"

Ca::Ca()
{
    pcl_Cf = new Cf(TRUE);
    c_Wrk_Mod= ' ';
    i_Win_Brd_Nli =10;			// Window Border Nbr of lines
    i_Win_Brd_Nco = LEN_MAX+8;		// Window Border Nbr of colones
					// 6 = 1 border + 1 sig + LEN_Max 
					// + 1 blank + 1 operation + 1 border
    i_Win_Brd_Ori_x = 5;			// Window Border Position above/left
    i_Win_Brd_Ori_y = 5;		
     
    i_Cur_Row_Nbr = 0;
    i_Fir_Row_Nbr = 0;
    i_Las_Row_Nbr = 0;

    pcl_Cur_Cel = new Op(NULL);
    pcl_Fir_Cel = pcl_Cur_Cel;
    pcl_Las_Cel_Pag = pcl_Cur_Cel;
    pcl_Fir_Cel_Pag = pcl_Cur_Cel;
    
    Cre_Win();

}
void Ca::Cre_Win()
{
     pw_Brd_Cel = newwin(	i_Win_Brd_Nli,				
    			i_Win_Brd_Nco,				
    			i_Win_Brd_Ori_x,				
    			i_Win_Brd_Ori_y );	

    keypad(pw_Brd_Cel,TRUE);			// keybord mapping
    idlok(pw_Brd_Cel,TRUE);			// insert delete lines
    scrollok(pw_Brd_Cel,TRUE);			
    Prt_Brd();
    
    pp_Pan_Brd = new_panel(pw_Brd_Cel);
    
    i_Win_Cel_Nli = i_Win_Brd_Nli-2;	// Window Cell Nbr of lines
    i_Win_Cel_Nco = i_Win_Brd_Nco-2;	// Window Cell Nbr of colones
    i_Win_Cel_x = i_Win_Brd_Ori_x+1;	// Window Cell Position above/left
    i_Win_Cel_y = i_Win_Brd_Ori_y+1;		
    pw_Win_Cel = newwin(	i_Win_Cel_Nli,				
    			i_Win_Cel_Nco,				
    			i_Win_Cel_x,				
    			i_Win_Cel_y);				
    keypad(pw_Win_Cel,TRUE);		// keybord mapping
    idlok(pw_Win_Cel,TRUE);		// insert delete lines
    scrollok(pw_Win_Cel,TRUE);			
    pp_Pan_Cel = new_panel(pw_Win_Cel);

    update_panels();
    doupdate();
}
void Ca::Del_Win()
{
}
void Ca::Get_Key()
{
    int i_Row_y = 0;
    int i_Row_x = 0;
    int b;
    while (TRUE)
    {	
	// reSet Cursor Position 
	pcl_Cur_Cel->Set_Cur(pw_Win_Cel,i_Row_y+i_Cur_Row_Nbr,i_Row_x); 
	
	i_c = wgetch(pw_Win_Cel);
	
	i_c = pcl_Cur_Cel->Get_Cel(pw_Win_Cel,i_c,i_Row_y+i_Cur_Row_Nbr,i_Row_x);

	// if cell modified recompute the total(s) 
	Upd_Tot();	

	// when blank, Get_Cel keep the control
	if (i_c != ' ')
	{ 

	    switch(c_Wrk_Mod)
	    {
		case ' ':
    		    switch(i_c)
		    {

			case KEY_LEFT:
		        case KEY_UP:
			    Mov_Prv_Cel();
			    break;

			case KEY_RIGHT:
			case KEY_DOWN:
			    Mov_Nxt_Cel();
			    break;

	    		case '=':
			    Add_Res_Cel();
	    		    break;

			case KEY_NPAGE:
			    Mov_Nxt_Pag();
		    	    break;

			case KEY_PPAGE:
			    Mov_Prv_Pag();
			    break;

//			case 'm':			// Change working mode to	
//			    c_Wrk_Mod = 'm';
//			    mvwaddstr(pw_Win_Cel,0,0,"Move");
//		    	    break;
//
//			case 's':			// Change working mode to
//				c_Wrk_Mod = 's';
//				mvwaddstr(pw_Win_Cel,0,0,"Resize");
//		    	    break;

	    		case 'c':				// Clear the screen
			    Clr_All();
			    break;

			case 'q':
			    return; 
			    break;
		    
			case 'r':
			    Prt_Pag(pcl_Fir_Cel_Pag,i_Fir_Row_Nbr); 
		    	    break;
			default :
			    break;
		    }
		    break;
		case 'm':
		    switch (i_c)
		    {
			case KEY_UP:
		    	    break;

		        case KEY_DOWN:
			    break;

			case KEY_LEFT:
			    break;

			case KEY_RIGHT:
			    break;
			    
			case 'm':
			    c_Wrk_Mod=' ';
			    Prt_Pag(pcl_Fir_Cel_Pag,i_Fir_Row_Nbr); 
			    break;
			    
			default:
			    break;
		    }
		case 's':
		    break;

		default:
		    break;
	    }	
	}
    }
    
         
}
void Ca::Prt_Brd()
{	
    if (FALSE)
    {
	// Term: VT100 or other..
	// ls,rs,ts,bs,tl,tr,bl,br
	wborder(pw_Brd_Cel,'!','!','-','-','+','+','+','+');
    }
    else
    {
	// Term: Linux
	wborder(pw_Brd_Cel,0,0,0,0,0,0,0,0);
    }
    	
}
void Ca::Prt_Pag(Cel *pcl_Fir_Cel_Pag,int i_Fir_Row_Nbr)
{
    wclear(pw_Win_Cel);
    Cel *pcl_Cel = pcl_Fir_Cel_Pag;
    int i=i_Fir_Row_Nbr;
    while (
	    i<=i_Win_Cel_Nli-1 
	    && 
	    pcl_Cel->pcl_Nxt_Cel != NULL 
	  )
    {
	pcl_Cel->Prt_Row(pw_Win_Cel,i,0);
	i++;
	pcl_Cel = pcl_Cel->pcl_Nxt_Cel;
    }
    pcl_Cel->Prt_Row(pw_Win_Cel,i,0);
    
}
void Ca::Mov_Nxt_Pag(void)
{
    if(pcl_Las_Cel_Pag->pcl_Nxt_Cel != NULL)
    {
        wclear(pw_Win_Cel);
	Cel *pcl_Cel = pcl_Las_Cel_Pag;
	int i=0;
	
	while (i<=i_Win_Cel_Nli-1)
	{
	    pcl_Cel->Prt_Row(pw_Win_Cel,i,0);
	    if(pcl_Cel->pcl_Nxt_Cel == NULL || i==i_Win_Cel_Nli-1 )
	    { break;}
	    else
	    { 
	    pcl_Cel = pcl_Cel->pcl_Nxt_Cel;
	    i++;
	    }
	}

	i_Cur_Row_Nbr	= 0;
	i_Fir_Row_Nbr	= 0;
	i_Las_Row_Nbr	= i;

	pcl_Fir_Cel_Pag	= pcl_Las_Cel_Pag;
	pcl_Las_Cel_Pag = pcl_Cel;
	pcl_Cur_Cel 	= pcl_Fir_Cel_Pag;
    }
}
void Ca::Mov_Prv_Pag(void)
{
    if(pcl_Fir_Cel_Pag->pcl_Pre_Cel != NULL)
    {
	wclear(pw_Win_Cel);
	Cel *pcl_Cel = pcl_Fir_Cel_Pag;
	int i=i_Win_Cel_Nli-1;
	while ( i>=0 )
	{
	    pcl_Cel->Prt_Row(pw_Win_Cel,i,0);
	    if (pcl_Cel->pcl_Pre_Cel == NULL || i==0 )
	    {
		break;
	    }
	    else
	    {
		pcl_Cel = pcl_Cel->pcl_Pre_Cel;
		i--;
	    }
	    
	}

	i_Fir_Row_Nbr 	= i;
	i_Las_Row_Nbr 	= i_Win_Cel_Nli-1;
	i_Cur_Row_Nbr 	= i_Las_Row_Nbr;

	pcl_Las_Cel_Pag	= pcl_Fir_Cel_Pag;
	pcl_Fir_Cel_Pag	= pcl_Cel;
	pcl_Cur_Cel 	= pcl_Las_Cel_Pag;
    }
}
void Ca::Mov_Prv_Cel(void)
{
    if (pcl_Cur_Cel->pcl_Pre_Cel != NULL) 
    {
	pcl_Cur_Cel = pcl_Cur_Cel->pcl_Pre_Cel;
	if(i_Cur_Row_Nbr == 0) 
	{
	    wscrl(pw_Win_Cel,-1);	//scroll down
	    pcl_Cur_Cel->Prt_Row(pw_Win_Cel,0,0);
	    pcl_Fir_Cel_Pag = pcl_Fir_Cel_Pag->pcl_Pre_Cel;
	    pcl_Las_Cel_Pag = pcl_Las_Cel_Pag->pcl_Pre_Cel;
	}
	else
	{
	    i_Cur_Row_Nbr--;
	}
    }

}
void Ca::Mov_Nxt_Cel(void)
{
    if (pcl_Cur_Cel->pcl_Nxt_Cel != NULL) 
    {
	// Existing Cell
	pcl_Cur_Cel = pcl_Cur_Cel->pcl_Nxt_Cel;
	if(i_Cur_Row_Nbr == i_Win_Cel_Nli-1)
	{
	    wscrl(pw_Win_Cel,+1);	//scroll up
	    pcl_Cur_Cel->Prt_Row(pw_Win_Cel,i_Cur_Row_Nbr,0);
	    pcl_Las_Cel_Pag = pcl_Las_Cel_Pag->pcl_Nxt_Cel;
	    if (i_Fir_Row_Nbr > 0) 
	    {
		i_Fir_Row_Nbr--;
	    }
	    else
	    {
	    pcl_Fir_Cel_Pag = pcl_Fir_Cel_Pag->pcl_Nxt_Cel;
	    }
	}
	else
	{
	    i_Cur_Row_Nbr++;
	}
    }
    else
    {	
	// Create New Cell
	pcl_Cur_Cel = new Op (pcl_Cur_Cel);
        if(i_Cur_Row_Nbr == i_Win_Cel_Nli-1)
	{
	    wscrl(pw_Win_Cel,+1);	//scroll up
	    pcl_Fir_Cel_Pag = pcl_Fir_Cel_Pag->pcl_Nxt_Cel;
	}
	else
	{
	    i_Cur_Row_Nbr++;
	    i_Las_Row_Nbr++;
	}
    	pcl_Las_Cel_Pag = pcl_Cur_Cel;
    }
     
}
void Ca::Clr_All()
{
    if(pcl_Fir_Cel != NULL)
    {
	pcl_Cur_Cel->Del_All_Cel(pcl_Fir_Cel);
        wclear(pw_Win_Cel);
        i_Cur_Row_Nbr=0;
        i_Fir_Row_Nbr=0;
        i_Las_Row_Nbr=0;
	pcl_Cur_Cel = new Op(NULL);
	pcl_Fir_Cel = pcl_Cur_Cel;
	pcl_Fir_Cel_Pag = pcl_Cur_Cel;
	pcl_Las_Cel_Pag = pcl_Cur_Cel;

    }

}
void Ca::Add_Res_Cel()
{
    if(pcl_Cur_Cel->pcl_Nxt_Cel != NULL)
    {
        //insertion
    }
    else
    {
	//creation
	pcl_Cur_Cel = new Rs(pcl_Cur_Cel,pcl_Fir_Cel);
	if(i_Cur_Row_Nbr == i_Win_Cel_Nli-1)
	{
	    pcl_Fir_Cel_Pag = pcl_Fir_Cel_Pag->pcl_Nxt_Cel;
	    wscrl(pw_Win_Cel,+1);	//scroll up
	}
	else
	{
	    i_Cur_Row_Nbr++;
	    i_Las_Row_Nbr++;
	}
	pcl_Las_Cel_Pag = pcl_Cur_Cel;
	pcl_Cur_Cel->Prt_Row(pw_Win_Cel,i_Cur_Row_Nbr,0);

    }	
}
void Ca::Upd_Tot(void)
{
	    if ( pcl_Cur_Cel->pcl_Nxt_Cel == NULL )
	    {
 		 pcl_Cur_Cel->Sav_Cel();
	    }
	    else
	    {
		if ( pcl_Cur_Cel->Get_Cel_Mod() )
	    
		{    
		    Acc *pcl_Fir_Acc;
		    Acc *pcl_Cur_Acc;

    		    pcl_Cur_Acc = new Acc(NULL);
		    pcl_Fir_Acc = pcl_Cur_Acc;

		    pcl_Fir_Acc->Cal_Tot(pcl_Fir_Cel);
		    delete pcl_Fir_Acc;
		    Prt_Pag(pcl_Fir_Cel_Pag,i_Fir_Row_Nbr); 
		    // save the data
 		    pcl_Cur_Cel->Sav_Cel();
		}	
	}    	
}

Ca::~Ca()
{
    if (pcl_Fir_Cel != NULL) 
    delete pcl_Fir_Cel;
}
