/**************************************************************************************************/
/*  Glo_Clf.C											  */
/**************************************************************************************************/
/*    Although I am far away to think this calculator can be useful as an aplication for accounter,
    
    Calc Vers 0.0001     Copyright (C)   2001 Marc Dechico

    This program is free software; you can redistribute it and/or modify
    it under the terms of the GNU General Public License as published by
    the Free Software Foundation; either version 2 of the License, or
    (at your option) any later version.

    This program is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.

    You should have received a copy of the GNU General Public License
    along with this program; if not, write to the Free Software
    Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA

    To contact the author:	Marc Dechico
			        Kerfring
			        29390 SCAER France
				tel: 06 80 83 74 99
				Mail: Marc.DECHICO@wanadoo.fr
    
*/
// Global definition for cal calculator

#include <panel.h>
#include <curses.h>
#include <stdlib.h>
#include <signal.h>
#include <ctype.h>
#include <string.h>

#define BLANC_SUR_NOIR	1
#define LEN_MAX   	12			// Nombre de chiffes permis 

#define LEN_MAX_DIG    		12		// Lenght  maxi of digits alowed 
#define LEN_MAX_CHA_CON  	26  		// Lenght maxi of char used for conversion 

void finish(int sig);

class Cf     					// Configuration  class 
{
public: //data

    enum Cel_Fmt	
    {
	EN_TH, 					// English format with thousand separator			
	EN,					// English   format without thousand separator	
	LA_TH,					// Latin     format with thousand separator
	LA,					// Latin     format with thousand separator
	CDS					// Condensed format no thousand separator
    };						//                  no decimal  separator
    int i_Nbr_Dec;				// Number of decimal
    enum Cel_Fmt  i_Cel_Fmt; 
private: //data

    struct s_Cel_Fmt
    {
	char tc_Fmt_Lib[20];			// Libel for explanation
	char tc_Fmt_Exe[10];			// Exemple of Format
	int  i_Len_Max;				// Lenght maximum on the screen
    };

    static struct s_Cel_Fmt ts_Cel_Fmt[5];
public: //function
    Cf(bool b_Fir_Cal);	
    ~Cf();	

private: //function
    void Set_Def_Par();				// Set the default parameters
};
struct  Cf::s_Cel_Fmt Cf:: ts_Cel_Fmt[5];
static  Cf *pcl_Def_Cf;				// Pointer on the default Configuration Class

class Cel
{
// Father of class Op and Rs

public: //data
    static Cf	*pcl_Cf;	//Configuration    	
    Cel		*pcl_Nxt_Cel;	//Next Cell   	
    Cel 	*pcl_Pre_Cel;   //Previous Cell	
    char	c_Ope; 		// Operation sign (+,-,*,/)
    char	c_Ope_sv; 		// Operation sign (+,-,*,/)
				// save for test modified 

private: //data

public: //function
    Cel();
    ~Cel();
    //static void Put_Cf(Cf *pcl_Cf_)   {pcl_Cf = pcl_Cf_;}
    void Del_Cel(Cel *pcl_Cur_Cel);
    void Del_All_Cel(Cel *pcl_Fir_Cel);
    virtual void Set_Cur(WINDOW *Win_Cel,int i_Row_y,int i_Row_x)=0;
    virtual void Prt_Row(WINDOW *Win_Cel,int i_Row_y,int i_Row_x)=0;
    virtual int  Get_Cel(WINDOW *Win_Cel,int i_c,int i_Row_y,int i_Row_x)=0;
    virtual long double  Get_Dig_Nbr()=0;
    virtual bool Get_Cel_Mod()=0;
    virtual void Sav_Cel()=0;

private: //function

};
static Cf *pcl_Cf ;				// Pointer on Configuration Class 


class Op : public Cel
{
public: //data
    long double 	d_Nbr;		// Number in decimal form
    long double 	d_Nbr_sv;	// Number in decimal form 
				// save for test modified 

private : //data
    enum Fld_Typ	
    {
	SIG,			
	NBR,	
	OPE,			
    };
    enum Fld_Typ e_Cur_Fld;	// Current Field
    
    char 	c_Sig;		// Sign
    char 	tc_Nbr[LEN_MAX]; // without '\0'
    int		i_Nbr_of_Cha;     // Number of type digits
    int 	i_Nbr_Cur_Pos;	// Curent position in the number

public : //function
    Op		(		
		    Cel *p_Cur_Cel
		);	
    virtual ~Op		();	

    void 	Del_Cel();
    void 	Prt_Row(WINDOW *Win_Cel,int i_Row_y,int i_Row_x);
    void 	Prt_Sig (WINDOW *Win_Cel,int i_Row_y,int i_Row_x);	
    void 	Prt_Nbr (WINDOW *Win_Cel,int i_Row_y,int i_Row_x);	
    void 	Prt_Ope (WINDOW *Win_Cel,int i_Row_y,int i_Row_x);	

    void 	Clr_Sig (WINDOW *Win_Cel,int i_Row_y,int i_Row_x);	
    void 	Clr_Nbr (WINDOW *Win_Cel,int i_Row_y,int i_Row_x);	
    void 	Clr_Ope (WINDOW *Win_Cel,int i_Row_y,int i_Row_x);

    virtual void Set_Cur (WINDOW *Win_Cel,int i_Row_y,int i_Row_x);	
    
    virtual int Get_Cel (WINDOW *Win_Cel,int i_c,int i_Row_y,int i_Row_x);	

    void 	Str_to_Num();
    virtual long double  Get_Dig_Nbr();
    virtual bool Get_Cel_Mod();
    virtual void Sav_Cel();

private :  //function
    int 	Get_Sig (WINDOW *Win_Cel,int i_c,int i_Row_y,int i_Row_x);	
    int 	Get_Nbr (WINDOW *Win_Cel,int i_c,int i_Row_y,int i_Row_x);	
    int 	Get_Ope (WINDOW *Win_Cel,int i_c,int i_Row_y,int i_Row_x);	
    void 	Mve_Lft ();		// Move to  the left
    void 	Mve_Rht_Bks ();		// Move to  the left for BackSpace
    void 	Mve_Rht_Dc ();		// Move to  the left for Delete

};

class Acc
{
public: //data
    Acc		*pcl_Nxt_Acc;	//Next Accumulator   	
    Acc 	*pcl_Pre_Acc;   //Previou Acc	
    long double d_Acc;
private: //data
public: //function
    Acc(Acc *pcl_Acc);
    ~Acc();
    long double Cal_Tot(Cel *pcl_Fir_Cel);
    
private: //function

};
class Rs : public Cel
{
public: //data
    long double 	d_Acc;			// Total in decimal form
private : //data
    
    char 	c_Sig;				// Sign
    char 	tc_Acc[LEN_MAX_DIG]; 		//Result 
    char 	tc_Acc_Wrk[LEN_MAX_CHA_CON]; 	//Result 
    int		i_Nbr_of_Cha;     		// Number  digits

public : //function
    Rs		(		
		    Cel *p_Cur_Cel,
		    Cel *p_Fir_Cel
		);	
    virtual ~Rs		();	

    void 	Del_Cel();
    void 	Prt_Row(WINDOW *Win_Cel,int i_Row_y,int i_Row_x);
    void 	Prt_Sig (WINDOW *Win_Cel,int i_Row_y,int i_Row_x);	
    void 	Prt_Acc (WINDOW *Win_Cel,int i_Row_y,int i_Row_x);	
    void 	Prt_Ope (WINDOW *Win_Cel,int i_Row_y,int i_Row_x);	

    void 	Clr_Sig (WINDOW *Win_Cel,int i_Row_y,int i_Row_x);	
    void 	Clr_Acc (WINDOW *Win_Cel,int i_Row_y,int i_Row_x);	
    void 	Clr_Ope (WINDOW *Win_Cel,int i_Row_y,int i_Row_x);

    virtual void Set_Cur (WINDOW *Win_Cel,int i_Row_y,int i_Row_x);	

    int 	Get_Ope (WINDOW *Win_Cel,int i_c,int i_Row_y,int i_Row_x);	
    virtual int Get_Cel (WINDOW *Win_Cel,int i_c,int i_Row_y,int i_Row_x);		
    virtual long double  Get_Dig_Nbr();
    virtual bool Get_Cel_Mod();
    virtual void Sav_Cel();

private :  //function
    void Num_to_Alp(long double d_Acc);
    void Clr_tc_Acc(void);
    friend class Acc;

};

class Ca
{

public : //data
//    Cf  *pcl_Cf;			// Configuration
    Cel *pcl_Fir_Cel;			// First Cell
    Cel *pcl_Cur_Cel;			// Curent Cell
    Cel *pcl_Fir_Cel_Pag;		// First Cell of page
    Cel *pcl_Las_Cel_Pag;		// Last  Cell of page
    int i_Cur_Row_Nbr;			// Curent Row Number 
					// ( 0 to i_Win_Cel_Nli-1)
    int i_Fir_Row_Nbr;			// Number of First Row being printed 
    int i_Las_Row_Nbr;			// Number of Last  Row being printed
    int i_c;				// key pressed

public : //function
    Ca();				// Constructor
    ~Ca();				// Destructor
    void Get_Key(void);			// Keyboard read
    void Prt_Brd();			// Print Border
    
private : //data
    
    WINDOW *pw_Brd_Cel;			// Window Pointer  for border
    WINDOW *pw_Win_Cel;			// Window Pointer  for the cells
    PANEL  *pp_Pan_Brd;			// Panel Pointer   for border
    PANEL  *pp_Pan_Cel;			// Panel Pointer   for the cells
    /**/
    int i_Win_Brd_Ori_x;		// Window Border Origine position 
    int i_Win_Brd_Ori_y;
    int i_Win_Brd_Nli;			// Window border nbr of lines
    int i_Win_Brd_Nco;			// Window border nbr of colones
    /**/
    int i_Win_Cel_Nli;			// Window cell nbr of lines
    int i_Win_Cel_Nco;			// Window cell nbr of colones
    int i_Win_Cel_x;			// Window cell  position
    int i_Win_Cel_y;			
    
    char c_Wrk_Mod;			// Working Mode 
					// ' ' = Normal mode
					// 'm' = Moving Window mode
					// 's' = Resizing Window mode
private : //funtion
    
    void Cre_Win();			// Create  the window
    void Del_Win();			// Delete  the window

    void Mov_Prv_Cel();			// Move Previous Cell
    void Mov_Nxt_Cel();			// Move Next	 Cell
    void Mov_Nxt_Pag(); 		// Move Next Page   
    void Mov_Prv_Pag(); 		// Move Previous Page

    void Add_Res_Cel();	 		// Add a New Result Cell
    void Upd_Tot();			// Update the total 

    void Clr_All();			// Clear All
    void Prt_Pag(Cel *pcl_Fir_Cel_Pag,int i_Fir_Row_Nbr); 
					// Print the current page
};

class Mai
{
public: 	// data

private: 	// data

public: 	// function
    Mai();
private: 	// function
    int Ini_Cur();

};
