/**************************************************************************************************/
/*  Res_Clf.C											  */
/**************************************************************************************************/
/*    Although I am far away to think this calculator can be useful as an aplication for accounter,
    
    Calc Vers 0.0001     Copyright (C)   2001 Marc Dechico

    This program is free software; you can redistribute it and/or modify
    it under the terms of the GNU General Public License as published by
    the Free Software Foundation; either version 2 of the License, or
    (at your option) any later version.

    This program is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.

    You should have received a copy of the GNU General Public License
    along with this program; if not, write to the Free Software
    Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA

    To contact the author:	Marc Dechico
			        Kerfring
			        29390 SCAER France
				tel: 06 80 83 74 99
				Mail: Marc.DECHICO@wanadoo.fr
    
*/
// Classe Res
// writing, updating, deleting a Result-Cell 
// a Result Cell  is made with a signe and number(not updatable)
// and an operation (updatable)

#include "Glo_Def.h"


Rs:: Rs(Cel  *pcl_Cur_Cel, Cel *pcl_Fir_Cel)
{	
    int b;
    if (pcl_Cur_Cel != NULL)  	// 
    { 
	pcl_Pre_Cel = pcl_Cur_Cel ;
	pcl_Pre_Cel->pcl_Nxt_Cel = this; 
    
    pcl_Nxt_Cel = NULL;	   	    
    i_Nbr_of_Cha = 0;		
    c_Sig	  = ' ';
    Acc *pcl_Fir_Acc;
    Acc *pcl_Cur_Acc;
    
    pcl_Cur_Acc = new Acc(NULL);
    pcl_Fir_Acc = pcl_Cur_Acc;
    
    d_Acc = pcl_Fir_Acc->Cal_Tot(pcl_Fir_Cel);
    delete pcl_Fir_Acc;
    // convert num to alpha 
    Num_to_Alp(d_Acc);
    c_Ope	  = ' ';
    c_Ope_sv	  = ' ';

    }

}
void Rs::Prt_Row(WINDOW *pw_Win_Cel,int i_Row_y,int i_Row_x)
{		
    Prt_Sig(pw_Win_Cel,i_Row_y,i_Row_x);
    Prt_Acc(pw_Win_Cel,i_Row_y,i_Row_x);
    Prt_Ope(pw_Win_Cel,i_Row_y,i_Row_x);
}
void Rs::Prt_Sig(WINDOW *pw_Win_Cel,int i_Row_y,int i_Row_x)
{		
    mvwaddch(
	    pw_Win_Cel,
	    i_Row_y ,
	    i_Row_x,
	    c_Sig
	    );  
}
void Rs::Prt_Acc(WINDOW *pw_Win_Cel,int i_Row_y,int i_Row_x)
{		
    int x,y,i,l;
    y= i_Row_y;
    x= i_Row_x +LEN_MAX;
    l= strlen(tc_Acc);
    if (l<=LEN_MAX)
    {
	for(i=l-1;i >=1 ;i--)
        {
		mvwaddch(pw_Win_Cel,y,x--,tc_Acc[i]);
        }
	if (tc_Acc[i] != '-')
	{ 	mvwaddch(pw_Win_Cel,y,x--,tc_Acc[i]);}
    }
    else
    {
	mvwaddstr(pw_Win_Cel,y,i_Row_x+1,tc_Acc);
    }
}
void Rs::Prt_Ope(WINDOW *pw_Win_Cel,int i_Row_y,int i_Row_x)
{		
    mvwaddch(
	    pw_Win_Cel,
	    i_Row_y,
	    i_Row_x + LEN_MAX +2,
	    c_Ope
	    );  
}
void Rs::Clr_Sig(WINDOW *pw_Win_Cel,int i_Row_y,int i_Row_x)
{		
    mvwaddch(
	    pw_Win_Cel,
	    i_Row_y ,
	    i_Row_x,
	    ' '
	    );  
}
void Rs::Clr_Acc(WINDOW *pw_Win_Cel,int i_Row_y,int i_Row_x)
{		
    int x,y,i;
    y= i_Row_y ;
    x= i_Row_x + 1;
    for(i=0;i < LEN_MAX ;i++)
    {
	mvwaddch(pw_Win_Cel,y,x++,' ');
    }
}
void Rs::Clr_Ope(WINDOW *pw_Win_Cel,int i_Row_y,int i_Row_x)
{		
    mvwaddch(
	    pw_Win_Cel,
	    i_Row_y ,
	    i_Row_x + LEN_MAX +2,
	    ' '
	    );  
}
void Rs::Set_Cur(WINDOW *pw_Win_Cel,int i_Row_y,int i_Row_x)
{
	    wmove(					
		pw_Win_Cel,
		i_Row_y ,
		i_Row_x + LEN_MAX + 2
	        );
    
}

int Rs::Get_Cel(WINDOW *pw_Win_Cel,int i_c,int i_Row_y,int i_Row_x)
{	

    i_c = Get_Ope(pw_Win_Cel,i_c,i_Row_y, i_Row_x);

    // Do not allow to create a new cell without needed info 
    if 	(
	    (i_c == KEY_RIGHT || i_c == KEY_DOWN ) 
	     && 
    	    ( c_Ope == ' ') 
	)
	
	{i_c = ' ';}

    return (i_c);
}
int Rs::Get_Ope(WINDOW *pw_Win_Cel,int i_c,int i_Row_y,int i_Row_x)
{
    switch (i_c)
    {
	case '-':
	case '+':
	case '*':
	case '/':
 	    c_Ope = i_c;
	    Prt_Ope(pw_Win_Cel,i_Row_y,i_Row_x);
	    return KEY_RIGHT;
	    break;
	case '=':
	case 't':
	    break;
	default :
	    return i_c;
	    break;
	    	    
    }	
    return ' ';
}
long double Rs:: Get_Dig_Nbr()
{
  return d_Acc;

}
void  Rs:: Num_to_Alp(long double d_Acc)
{
    int decpt;
    int sign;
    
    Clr_tc_Acc();
    fcvt_r(d_Acc,0,&decpt,&sign,tc_Acc_Wrk,LEN_MAX_CHA_CON);
    if ( sign != 0 ) c_Sig = '-';
    if ( strlen(tc_Acc_Wrk) <= 12 )
    {
	strcpy( tc_Acc ,tc_Acc_Wrk );
    }
    else
    {
	strcpy( tc_Acc , "Ovrflow");
    }
    
}
void  Rs:: Clr_tc_Acc(void)
{
    int i;
    for (i=0;i<LEN_MAX+1;i++)   tc_Acc[i]= ' ';
    tc_Acc[LEN_MAX]='\0';

}
bool  Rs:: Get_Cel_Mod(void)
{
    if(c_Ope != c_Ope_sv)
    {return true;}
    else 
    {return false;}
}
void  Rs::Sav_Cel(void)
{
    c_Ope_sv = c_Ope;
}

Rs:: ~Rs()
{

}
